Attribute VB_Name = "ESC_POS_CMD"
Option Explicit

Private Const HT As Integer = 9
Private Const LF As Integer = 10
Private Const FF As Integer = 12
Private Const CR As Integer = 13
Private Const CAN As Integer = 24
Private Const DLE As Integer = 16
Private Const EOT As Integer = 4
Private Const ENQ As Integer = 5
Private Const DC4 As Integer = 20
Private Const ESC As Integer = 27
Private Const SP As Integer = 32
Private Const FS As Integer = 28
Private Const GS As Integer = 29

Private Const Zero As Integer = 48                  '0
Private Const Two As Integer = 50                   '1
Private Const Three As Integer = 51                 '2
Private Const Four As Integer = 52
Private Const Five As Integer = 53
Private Const Eight As Integer = 56

Private Const Dot As Integer = 46                   '.
Private Const Exclamation_Point As Integer = 33     '!
Private Const Dollar_Sign As Integer = 36           '$@Dollar sign (Ÿ)
Private Const Percent_Sign As Integer = 37          '%@Percent, percent sign (ʤAʤŸ)
Private Const Ampersand As Integer = 38             '&@Ampersand (And Ÿ)
Private Const Asterisk As Integer = 42              '*@Asterisk (P)
Private Const Hyphen As Integer = 45                '-@Hyphen (sr)
Private Const Equals As Integer = 61                '=@Equals ()
Private Const Caret As Integer = 94                 '^@Caret (J)
Private Const Question_Mark As Integer = 63         '?  Question Mark
Private Const BackSlash As Integer = 92             '\@Backslash (ϱ׽u)
Private Const Slash As Integer = 47
Private Const Open_Brace As Integer = 123           '{@Open brace (jA)
Private Const Open_Parenthesis = 40                 '(@Open parenthesis (A)
Private Const AT As Integer = 64                    '@@At sign, at (At ŸAAt)
Private Const Colon As Integer = 58                 ': Colon (_)

'[@Open bracket (A)
']@Close bracket (kA)
')@Close parenthesis (kA)
',@Comma (r)
'--@Double dash (}鸹)
'...@Ellipsis (ٲŸ)
''@Single quote (޸)
'"@Quote (޸)
'+@Plus, plus sign ([A[)
'!@Exclamation point (۸)
'>@Greater than (j)
'<@Less than (p)
'#@Pound sign (r)
'Print Question; mark(ݸ)
'.Period , dot(y, I)
';@Semicolon ()
'X@Dash (}鸹)
'_@Underscore (u)
'|@Vertical bar (u)
'}@Close brace (kjA)
'/@Slash (׽u)
'//@Double slash (׽u)
'~@Tilde (NŸA)

Private Const Fn0 As Integer = 0
Private Const Fn1 As Integer = 1
Private Const Fn2 As Integer = 2
Private Const Fn3 As Integer = 3
Private Const Fn4 As Integer = 4
Private Const Fn5 As Integer = 5
Private Const Fn6 As Integer = 6
Private Const Fn7 As Integer = 7
Private Const Fn8 As Integer = 8
Private Const Fn9 As Integer = 9
Private Const Fn10 As Integer = 10
Private Const Fn11 As Integer = 11
Private Const Fn12 As Integer = 12
Private Const Fn13 As Integer = 13
Private Const Fn14 As Integer = 14
Private Const Fn15 As Integer = 15
Private Const Fn16 As Integer = 16
Private Const Fn17 As Integer = 17
Private Const Fn18 As Integer = 18
Private Const Fn19 As Integer = 19
Private Const Fn20 As Integer = 20
Private Const Fn21 As Integer = 21
Private Const Fn22 As Integer = 22
Private Const Fn23 As Integer = 23

Private Const Fn33 As Integer = 33
Private Const Fn34 As Integer = 34
Private Const Fn48 As Integer = 48
Private Const Fn65 As Integer = 65
Private Const Fn66 As Integer = 66
Private Const Fn67 As Integer = 67
Private Const Fn68 As Integer = 68
Private Const Fn97 As Integer = 97

Private Const A As Integer = 65
Private Const B As Integer = 66
Private Const c As Integer = 67
Private Const D As Integer = 68
Private Const E As Integer = 69
Private Const F As Integer = 70
Private Const G As Integer = 71
Private Const H As Integer = 72
Private Const I As Integer = 73
Private Const J As Integer = 74
Private Const K As Integer = 75
Private Const L As Integer = 76
Private Const M As Integer = 77
Private Const N As Integer = 78
Private Const O As Integer = 79
Private Const P As Integer = 80
Private Const Q As Integer = 81
Private Const R As Integer = 82
Private Const S As Integer = 83
Private Const T As Integer = 84
Private Const U As Integer = 85
Private Const V As Integer = 86
Private Const W As Integer = 87
Private Const X As Integer = 88
Private Const Y As Integer = 89
Private Const Z As Integer = 90
Private Const aa As Integer = 97
Private Const bb As Integer = 98
Private Const cc As Integer = 99
Private Const dd As Integer = 100
Private Const ee As Integer = 101
Private Const fff As Integer = 102
Private Const gg As Integer = 103
Private Const hh As Integer = 104
Private Const ii As Integer = 105
Private Const jj As Integer = 106
Private Const kk As Integer = 107
Private Const ll As Integer = 108
Private Const mm As Integer = 109
Private Const nn As Integer = 110
Private Const oo As Integer = 111
Private Const pp As Integer = 112
Private Const qq As Integer = 113
Private Const rr As Integer = 114
Private Const SS As Integer = 115
Private Const tt As Integer = 116
Private Const uu As Integer = 117
Private Const vv As Integer = 118
Private Const ww As Integer = 119
Private Const xx As Integer = 120
Private Const yy As Integer = 121
Private Const zz As Integer = 122

Public Function CAN_CMD() As Byte
    'Ver. 10.06 p.91
    'CAN
    'EXECUTING Command
    '[Name] Cancel print data in page mode
    '[Format]   ASCII   CAN
    '           Hex     18
    '           Decimal 24
    '[Range] None
    '[Default] None
    '[Printers not featuring this command] TM - U230, TM - U220
    '[Description] In page mode, deletes all the print data in the current print area.
    '[Notes]
    ' This command is enabled only in page mode. Page mode is selected by ESC L.
    ' If data set in the previously specified print area is set in the currently specified print area, it is deleted.
    '[Model-dependent variations] None

    CAN_CMD = CAN

End Function

Public Function CR_CMD() As Byte
    'Ver. 10.06 p.70
    '[Name] Print and cRetCodeiage return
    '[Format]   ASCII   CR
    '           Hex     0D
    '           Decimal 13
    '[Range] None
    '[Default] None
    '[Printers not featuring this command] TM - P60
    '[Description] Executes one of the following operations.
    '[Notes]
    ' With a serial interface, the command performs as if auto line feed is disabled.
    ' With a parallel interface, enabling or disabling the auto line feed can be selected by the DIP switch or the
    '   memory switch. Memory switch can be changed with GS ( E <Function3>.
    ' After printing, the print position moves to the beginning of the line. When a left margin is set in standard
    '   mode, the position of the left margin is the beginning of the line.
    ' When this command is processed in page mode, only the print position moves, and the printer does not
    '   perform actual printing.

    CR_CMD = CR

End Function

Public Function DLE_DC4_FN1_CMD(ByVal Drawer_Pin As Integer, ByVal Pulse_Time As Integer) As Byte()

    ReDim ESC_POS_CMD(4) As Byte

    ESC_POS_CMD(0) = DLE
    ESC_POS_CMD(1) = DC4
    ESC_POS_CMD(2) = Fn1
    ESC_POS_CMD(3) = Drawer_Pin
    ESC_POS_CMD(4) = Pulse_Time

    DLE_DC4_FN1_CMD = ESC_POS_CMD
    
End Function

Public Function DLE_DC4_FN2_CMD() As Byte()

    ReDim ESC_POS_CMD(4) As Byte

    ESC_POS_CMD(0) = DLE
    ESC_POS_CMD(1) = DC4
    ESC_POS_CMD(2) = Fn2
    ESC_POS_CMD(3) = 1
    ESC_POS_CMD(4) = 8

    DLE_DC4_FN2_CMD = ESC_POS_CMD
    
End Function

Public Function DLE_DC4_FN8_CMD() As Byte()

    ReDim ESC_POS_CMD(9) As Byte

    ESC_POS_CMD(0) = DLE
    ESC_POS_CMD(1) = DC4
    ESC_POS_CMD(2) = Fn8
    ESC_POS_CMD(3) = 1
    ESC_POS_CMD(4) = 3
    ESC_POS_CMD(5) = 20
    ESC_POS_CMD(6) = 1
    ESC_POS_CMD(7) = 6
    ESC_POS_CMD(8) = 2
    ESC_POS_CMD(9) = 8

    DLE_DC4_FN8_CMD = ESC_POS_CMD
    
End Function

Public Function DLE_ENQ_CMD(ByVal Request As Integer) As Byte()
    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = DLE
    ESC_POS_CMD(1) = ENQ
    ESC_POS_CMD(2) = Request

    DLE_ENQ_CMD = ESC_POS_CMD
    
End Function

Public Function DLE_EOT_CMD(ByVal Status As Integer) As Byte()
    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = DLE
    ESC_POS_CMD(1) = EOT
    ESC_POS_CMD(2) = Status

    DLE_EOT_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_AT_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = AT
    
    ESC_AT_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Ampersand_CMD(Height As Integer, StartCode As Integer, EndCode As Integer, FontData() As Byte) As Byte()
    
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(FontData())
    ReDim ESC_POS_CMD(5 + RetCodeayLength) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Ampersand
    ESC_POS_CMD(2) = Height
    ESC_POS_CMD(3) = StartCode
    ESC_POS_CMD(4) = EndCode
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(5 + Counter) = FontData(Counter)
        
    Next Counter
    
    ESC_Ampersand_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Asterisk_CMD(Bit_Image_Mode As Integer, L_Image_Dots As Integer, H_Image_Dots As Integer, BitMapData() As Byte) As Byte()
    
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(BitMapData())
    ReDim ESC_POS_CMD(5 + RetCodeayLength) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Asterisk
    ESC_POS_CMD(2) = Bit_Image_Mode
    ESC_POS_CMD(3) = L_Image_Dots
    ESC_POS_CMD(4) = H_Image_Dots
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(5 + Counter) = BitMapData(Counter)
        
    Next Counter
    
    ESC_Asterisk_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_BackSlash_CMD(L_Position As Integer, H_Position As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = BackSlash
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
    
    ESC_BackSlash_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_D_CMD(PositionData() As Byte) As Byte()

    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(PositionData())
    ReDim ESC_POS_CMD(3 + RetCodeayLength) As Byte
    
    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = D

    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(2 + Counter) = PositionData(Counter)
        
    Next Counter
    
    ESC_POS_CMD(3 + RetCodeayLength) = 0 'Null
    
    ESC_D_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Dollar_Sign_CMD(L_Position As Integer, H_Position As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Dollar_Sign
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
     
    ESC_Dollar_Sign_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_EQUALS_CMD(Device As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Equals
    ESC_POS_CMD(2) = Device
    
    ESC_EQUALS_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_E_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = E
    ESC_POS_CMD(2) = Mode
    
    ESC_E_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Exclamation_Point_CMD(Modes As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Exclamation_Point
    ESC_POS_CMD(2) = Modes
    
    ESC_Exclamation_Point_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_FF_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = FF
    
    ESC_FF_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_G_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = G
    ESC_POS_CMD(2) = Mode
    
    ESC_G_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Hyphen_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Hyphen
    ESC_POS_CMD(2) = Mode
     
    ESC_Hyphen_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_J_CMD(FeedLines_Unit As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = J
    ESC_POS_CMD(2) = FeedLines_Unit
    
    ESC_J_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_L_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = L
    
    ESC_L_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_M_CMD(FontTypes As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = M
    ESC_POS_CMD(2) = FontTypes
    
    ESC_M_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Open_Brace_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Open_Brace
    ESC_POS_CMD(2) = Mode
    
    ESC_Open_Brace_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Open_Parenthesis_A_Fn97_CMD(Pattern As Integer, Run_Times As Integer) As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = A
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0 'Null
    ESC_POS_CMD(5) = Fn97
    ESC_POS_CMD(6) = Pattern
    ESC_POS_CMD(7) = Run_Times
    
    ESC_Open_Parenthesis_A_Fn97_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Percent_Sign_CMD(Action As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Percent_Sign
    ESC_POS_CMD(2) = Action
     
    ESC_Percent_Sign_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Question_Mark_CMD(Character_Code As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Question_Mark
    ESC_POS_CMD(2) = Character_Code
    
    ESC_Question_Mark_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_R_CMD(Character_Set As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = R
    ESC_POS_CMD(2) = Character_Set
    
    ESC_R_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_SP_CMD(Spacing As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = SP
    ESC_POS_CMD(2) = Spacing
    
    ESC_SP_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_S_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = S
    
    ESC_S_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_T_CMD(Print_Direction As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = T
    ESC_POS_CMD(2) = Print_Direction
    
    ESC_T_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Three_CMD(Line_Spacing As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Three
    ESC_POS_CMD(2) = Line_Spacing
    
    ESC_Three_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_Two_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = Two
     
    ESC_Two_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_V_CMD(Rotation_Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = V
    ESC_POS_CMD(2) = Rotation_Mode
    
    ESC_V_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_W_CMD(XL As Integer, XH As Integer, YL As Integer, YH As Integer, DXL As Integer, DXH As Integer, DYL As Integer, DYH As Integer) As Byte()

    ReDim ESC_POS_CMD(9) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = W
    ESC_POS_CMD(2) = XL
    ESC_POS_CMD(3) = XH
    ESC_POS_CMD(4) = YL
    ESC_POS_CMD(5) = YH
    ESC_POS_CMD(6) = DXL
    ESC_POS_CMD(7) = DXH
    ESC_POS_CMD(8) = DYL
    ESC_POS_CMD(9) = DYH
    
    ESC_W_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_aa_CMD(Justification As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = aa
    ESC_POS_CMD(2) = Justification
    
    ESC_aa_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_cc_Five_CMD(Panel_Button As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = cc
    ESC_POS_CMD(2) = Five
    ESC_POS_CMD(3) = Panel_Button
        
    ESC_cc_Five_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_cc_Four_CMD(Paper_Sensor As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = cc
    ESC_POS_CMD(2) = Four
    ESC_POS_CMD(3) = Paper_Sensor
        
    ESC_cc_Four_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_cc_Three_CMD(Paper_Sensor As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = cc
    ESC_POS_CMD(2) = Three
    ESC_POS_CMD(3) = Paper_Sensor
        
    ESC_cc_Three_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_dd_CMD(Lines As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = dd
    ESC_POS_CMD(2) = Lines
    
    ESC_dd_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_pp_CMD(Drawers_Pin As Integer, Time_On As Integer, Time_Off As Integer) As Byte()

    ReDim ESC_POS_CMD(4) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = pp
    ESC_POS_CMD(2) = Drawers_Pin
    ESC_POS_CMD(3) = Time_On
    ESC_POS_CMD(4) = Time_Off
    
    ESC_pp_CMD = ESC_POS_CMD
    
End Function

Public Function ESC_tt_CMD(Code_Table As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = ESC
    ESC_POS_CMD(1) = tt
    ESC_POS_CMD(2) = Code_Table
    
    ESC_tt_CMD = ESC_POS_CMD
    
End Function

Public Function FF_CMD() As Byte
    'Ver. 10.06 p.68
    'FF (in page mode)
    'EXECUTING Command
    '[Name] Print and return to standard mode (in page mode)
    '[Format]   ASCII   FF
    '           Hex     0C
    '           Decimal 12
    '[Default] None
    '[Range] None
    '[Printers not featuring this command] TM - U230, TM - U220
    '[Description] In page mode, prints all the data in the print buffer collectively and switches from page mode to standard mode.
    '[Notes]
    ' This command is enabled only in page mode. See FF (in standard mode) to use this command in standard mode. Page mode can be selected by ESC L or FS L.
    ' The data is deleted in the print area after being printed.
    ' This command returns the values set by ESC W to the default values.
    ' The value set by ESC T is maintained.
    ' After printing, the print position moves to the beginning of the line. When a left margin is set, the position of the left margin is the beginning of the line.
    '[Model-dependent variations] None

    FF_CMD = FF
    
End Function

Public Function FS_Ampersand_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Ampersand
    
    FS_Ampersand_CMD = ESC_POS_CMD
    
End Function

Public Function FS_C_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = c
    ESC_POS_CMD(2) = Mode
    
    FS_C_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Dot_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Dot
    
    FS_Dot_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Exclamation_Point_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Exclamation_Point
    ESC_POS_CMD(2) = Mode
    
    FS_Exclamation_Point_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Hyphen_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Hyphen
    ESC_POS_CMD(2) = Mode
    
    FS_Hyphen_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_A_Fn48_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = A
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0 'Null
    ESC_POS_CMD(5) = Fn48
    ESC_POS_CMD(6) = Mode
    
    FS_Open_Parenthesis_A_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn33_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L

    FS_Open_Parenthesis_L_Fn33_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn34_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    FS_Open_Parenthesis_L_Fn34_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn48_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    FS_Open_Parenthesis_L_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn65_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    FS_Open_Parenthesis_L_Fn65_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn66_CMD(ByVal Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte

    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 66
    ESC_POS_CMD(6) = Mode
    
    FS_Open_Parenthesis_L_Fn66_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn67_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte

    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    FS_Open_Parenthesis_L_Fn67_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Open_Parenthesis_L_Fn80_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    FS_Open_Parenthesis_L_Fn80_CMD = ESC_POS_CMD
    
End Function

Public Function FS_S_CMD(L_Position As Integer, H_Position) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = S
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
    
    FS_S_CMD = ESC_POS_CMD
    
End Function

Public Function FS_Two_CMD(StartCode As Integer, EndCode As Integer, FontData() As Byte) As Byte()
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(FontData())
    ReDim ESC_POS_CMD(4 + RetCodeayLength) As Byte
    
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Two
    ESC_POS_CMD(2) = StartCode
    ESC_POS_CMD(3) = EndCode
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(4 + Counter) = FontData(Counter)
        
    Next Counter
    
    FS_Two_CMD = ESC_POS_CMD
    
End Function

Public Function FS_W_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = W
    ESC_POS_CMD(2) = Mode
    
    FS_W_CMD = ESC_POS_CMD
    
End Function

Public Function FS_pp_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = pp
    ESC_POS_CMD(2) = Image_No
    ESC_POS_CMD(3) = Mode
    
    FS_pp_CMD = ESC_POS_CMD
    
End Function
Public Function FS_Question_Mark_CMD(HighByte As Integer, LowByte As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    
    ESC_POS_CMD(0) = FS
    ESC_POS_CMD(1) = Question_Mark
    ESC_POS_CMD(2) = HighByte
    ESC_POS_CMD(3) = LowByte
    
    FS_Question_Mark_CMD = ESC_POS_CMD
    
End Function

'Asterisk
Public Function GS_Asterisk_CMD(Horizontal_X As Byte, Vertical_Y As Byte, BitMapData() As Byte) As Byte()
    
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(BitMapData())
    ReDim ESC_POS_CMD(4 + RetCodeayLength) As Byte

    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Asterisk
    ESC_POS_CMD(2) = Horizontal_X
    ESC_POS_CMD(3) = Vertical_Y
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(4 + Counter) = BitMapData(Counter)
        
    Next Counter

    GS_Asterisk_CMD = ESC_POS_CMD
    
End Function

Public Function GS_B_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = B
    ESC_POS_CMD(2) = Mode
    
    GS_B_CMD = ESC_POS_CMD
    
End Function

Public Function GS_BackSlash_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = BackSlash
    ESC_POS_CMD(2) = Mode
    
    GS_BackSlash_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Caret_CMD(Run_Times As Integer, Interval_time As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(4) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Caret
    ESC_POS_CMD(2) = Run_Times
    ESC_POS_CMD(3) = Interval_time
    ESC_POS_CMD(4) = Mode
    
    GS_Caret_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Colon_CMD() As Byte()

    ReDim ESC_POS_CMD(1) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Colon
    
    GS_Colon_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Dollar_Sign_CMD(L_Position As Integer, H_Position As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Dollar_Sign
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
    
    GS_Dollar_Sign_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Eight_L_Fn112_CMD(P14() As Byte, X2 As Integer, Y2 As Integer, XL As Byte, XH As Byte, YL As Byte, YH As Byte, BitMapData() As Byte) As Byte()
    
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(BitMapData())
    ReDim ESC_POS_CMD(17 + RetCodeayLength) As Byte
    
    'ReDim ESC_POS_CMD(3) As Byte
    
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Eight
    ESC_POS_CMD(2) = 76
    ESC_POS_CMD(3) = P14(0)
    ESC_POS_CMD(4) = P14(1)
    ESC_POS_CMD(5) = P14(2)
    ESC_POS_CMD(6) = P14(3)
    ESC_POS_CMD(7) = 48
    ESC_POS_CMD(8) = 112
    ESC_POS_CMD(9) = 48
    ESC_POS_CMD(10) = X2
    ESC_POS_CMD(11) = Y2
    ESC_POS_CMD(12) = 49
    ESC_POS_CMD(13) = XL
    ESC_POS_CMD(14) = XH
    ESC_POS_CMD(15) = YL
    ESC_POS_CMD(16) = YH
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(17 + Counter) = BitMapData(Counter)
        
    Next Counter
    
    '    LoadBMP_GS_v_0(ByVal picName As String, ByRef P14() As Byte, ByRef XLH() As Byte, ByRef YLH() As Byte, ByRef ESC_BitMap() As Byte)
    'GS_vv_Zero_CMD(Mode As Integer, XL As Byte, XH As Byte, YL As Byte, YH As Byte, BitMapData() As Byte
    
    GS_Eight_L_Fn112_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Exclamation_Point_CMD(Size As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Exclamation_Point
    ESC_POS_CMD(2) = Size
    
    GS_Exclamation_Point_CMD = ESC_POS_CMD
    
End Function

Public Function GS_H_CMD(Position As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = H
    ESC_POS_CMD(2) = Position
    
    GS_H_CMD = ESC_POS_CMD
    
End Function

Public Function GS_I_CMD(ID As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = I
    ESC_POS_CMD(2) = ID
    
    GS_I_CMD = ESC_POS_CMD
    
End Function

Public Function GS_L_CMD(L_Position As Integer, H_Position As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = L
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
    
    GS_L_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_A_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = A
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = Paper_Type
    ESC_POS_CMD(6) = Test_Pattern
    
    GS_Open_Parenthesis_A_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn0_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn0
    
    GS_Open_Parenthesis_C_Fn0_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn1_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn1
    
    GS_Open_Parenthesis_C_Fn1_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn2_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn2
    
    GS_Open_Parenthesis_C_Fn2_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn3_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn3
    
    GS_Open_Parenthesis_C_Fn3_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn4_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn4
    
    GS_Open_Parenthesis_C_Fn4_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn5_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn5
    
    GS_Open_Parenthesis_C_Fn5_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_C_Fn6_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = c
    ESC_POS_CMD(3) = Fn6
    
    GS_Open_Parenthesis_C_Fn6_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_D_CMD(Command_Type As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = D
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 20
    ESC_POS_CMD(6) = Command_Type
    ESC_POS_CMD(7) = Mode
    
    GS_Open_Parenthesis_D_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn10_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn10_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn11_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn11_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn12_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn12_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn13_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn13_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn14_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn14_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn1_CMD() As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 1
    ESC_POS_CMD(6) = 73
    ESC_POS_CMD(7) = 78
    
    GS_Open_Parenthesis_E_Fn1_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn2_CMD() As Byte()

    ReDim ESC_POS_CMD(8) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    ESC_POS_CMD(3) = 4
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 2
    ESC_POS_CMD(6) = 79
    ESC_POS_CMD(7) = 85
    ESC_POS_CMD(8) = 84
    
    GS_Open_Parenthesis_E_Fn2_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn3_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn3_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn48_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn49_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn49_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn4_CMD(MemSW As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 4
    ESC_POS_CMD(6) = MemSW
 
    GS_Open_Parenthesis_E_Fn4_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn50_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn50_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn5_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn5_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn6_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn6_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn7_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn7_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn8_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn8_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_E_Fn9_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = E
    
    GS_Open_Parenthesis_E_Fn9_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_H_Fn48_CMD(ByVal D1 As Integer, ByVal D2 As Integer, ByVal D3 As Integer, ByVal D4 As Integer) As Byte()

    ReDim ESC_POS_CMD(10) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = H
    ESC_POS_CMD(3) = 6
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 48
    ESC_POS_CMD(7) = D1
    ESC_POS_CMD(8) = D2
    ESC_POS_CMD(9) = D3
    ESC_POS_CMD(10) = D4
    
    GS_Open_Parenthesis_H_Fn48_CMD = ESC_POS_CMD
    
End Function

'Public Function GS_Open_Parenthesis_H_Fn48_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()
'
'    ReDim ESC_POS_CMD(6) As Byte
'    ESC_POS_CMD(0) = GS
'    ESC_POS_CMD(1) = Open_Parenthesis
'    ESC_POS_CMD(2) = H
'
'    GS_Open_Parenthesis_H_Fn48_CMD = ESC_POS_CMD
'
'End Function

Public Function GS_Open_Parenthesis_H_Fn49_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = H
    
    GS_Open_Parenthesis_H_Fn49_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_K_Fn48_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = K
    
    GS_Open_Parenthesis_K_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_K_Fn49_CMD(Density As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = K
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = Density
    GS_Open_Parenthesis_K_Fn49_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_K_Fn50_CMD(Speed As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = K
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 50
    ESC_POS_CMD(6) = Speed
    GS_Open_Parenthesis_K_Fn50_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_K_Fn97_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = K
    
    GS_Open_Parenthesis_K_Fn97_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn112_CMD(P14() As Byte, X2 As Integer, Y2 As Integer, XL As Byte, XH As Byte, YL As Byte, YH As Byte, BitMapData() As Byte) As Byte()
    
    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(BitMapData())
    ReDim ESC_POS_CMD(17 + RetCodeayLength) As Byte
    
    'ReDim ESC_POS_CMD(3) As Byte
    
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = P14(0)
    ESC_POS_CMD(4) = P14(1)
    ESC_POS_CMD(5) = P14(2)
    ESC_POS_CMD(6) = P14(3)
    ESC_POS_CMD(7) = 48
    ESC_POS_CMD(8) = 112
    ESC_POS_CMD(9) = 48
    ESC_POS_CMD(10) = X2
    ESC_POS_CMD(11) = Y2
    ESC_POS_CMD(12) = 49
    ESC_POS_CMD(13) = XL
    ESC_POS_CMD(14) = XH
    ESC_POS_CMD(15) = YL
    ESC_POS_CMD(16) = YH
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(17 + Counter) = BitMapData(Counter)
        
    Next Counter
    
    GS_Open_Parenthesis_L_Fn112_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn113_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn113_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn48_CMD(ByVal D1 As Integer, ByVal D2 As Integer, ByVal D3 As Integer, ByVal D4 As Integer) As Byte()

    ReDim ESC_POS_CMD(10) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 6
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 48
    ESC_POS_CMD(7) = D1
    ESC_POS_CMD(8) = D2
    ESC_POS_CMD(9) = D3
    ESC_POS_CMD(10) = D4
    
    GS_Open_Parenthesis_L_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn49_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn49_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn50_CMD() As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 2
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 2
    
    GS_Open_Parenthesis_L_Fn50_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn51_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn51_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn52_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn52_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn64_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn64_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn65_CMD() As Byte()

    ReDim ESC_POS_CMD(9) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 5
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 65
    ESC_POS_CMD(7) = 67
    ESC_POS_CMD(8) = 76
    ESC_POS_CMD(9) = 82
    
    GS_Open_Parenthesis_L_Fn65_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn66_CMD(ByVal KeyCode1 As Integer, ByVal KeyCode2 As Integer) As Byte()

    ReDim ESC_POS_CMD(8) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 4
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 66
    ESC_POS_CMD(7) = KeyCode1
    ESC_POS_CMD(8) = KeyCode2
    
    GS_Open_Parenthesis_L_Fn66_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn67_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn67_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn68_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn68_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn69_CMD(KeyCode1 As Integer, KeyCode2 As Integer, Width As Integer, Height As Integer) As Byte()

    ReDim ESC_POS_CMD(10) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    ESC_POS_CMD(3) = 6
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 48
    ESC_POS_CMD(6) = 69
    ESC_POS_CMD(7) = KeyCode1
    ESC_POS_CMD(8) = KeyCode2
    ESC_POS_CMD(9) = Width
    ESC_POS_CMD(10) = Height
    
    'ESC_POS_CMD(2) = L
    'ESC_POS_CMD(2) = L
    'ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn69_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn80_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn80_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn81_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn81_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn82_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn82_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn83_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn83_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn84_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn84_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_L_Fn85_CMD(Image_No As Integer, Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = L
    
    GS_Open_Parenthesis_L_Fn85_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_M_Fn1_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = M
    
    GS_Open_Parenthesis_M_Fn1_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_M_Fn2_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = M
    
    GS_Open_Parenthesis_M_Fn2_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_M_Fn3_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = M
    
    GS_Open_Parenthesis_M_Fn3_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_N_Fn48_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = N
    
    GS_Open_Parenthesis_N_Fn48_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_N_Fn49_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = N
    
    GS_Open_Parenthesis_N_Fn49_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_N_Fn50_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = N
    
    GS_Open_Parenthesis_N_Fn50_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn165_CMD(ByVal Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(8) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    ESC_POS_CMD(3) = 4
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = 65
    ESC_POS_CMD(7) = Mode
    ESC_POS_CMD(8) = 0
    
    GS_Open_Parenthesis_kk_Fn165_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn167_CMD(ByVal QRSize As Integer) As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = 67
    ESC_POS_CMD(7) = QRSize
    
    GS_Open_Parenthesis_kk_Fn167_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn169_CMD(ByVal EC_Level As Integer) As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = 69
    ESC_POS_CMD(7) = EC_Level
    
    GS_Open_Parenthesis_kk_Fn169_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn180_CMD(PrintData() As Byte) As Byte()
    
    Dim QRLength As Long
    Dim Pl As Integer
    Dim Ph As Integer
    
    QRLength = UBound(PrintData()) + 1
 '
    ReDim ESC_POS_CMD(QRLength + 7) As Byte

    Pl = (QRLength + 3) Mod 256
    Ph = Int((QRLength + 3) / 256)

    Dim Counter As Integer

    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    ESC_POS_CMD(3) = Pl
    ESC_POS_CMD(4) = Ph
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = 80
    ESC_POS_CMD(7) = 48

    For Counter = 1 To QRLength
        
        ESC_POS_CMD(7 + Counter) = PrintData(Counter - 1)
        Debug.Print Hex(ESC_POS_CMD(Counter + 7)); " ";
        
    Next Counter

    GS_Open_Parenthesis_kk_Fn180_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn181_CMD() As Byte()

    ReDim ESC_POS_CMD(7) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    ESC_POS_CMD(3) = 3
    ESC_POS_CMD(4) = 0
    ESC_POS_CMD(5) = 49
    ESC_POS_CMD(6) = 81
    ESC_POS_CMD(7) = 48
    
    GS_Open_Parenthesis_kk_Fn181_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn182_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn182_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn265_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn265_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn280_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn280_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn281_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn281_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn282_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn282_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn367_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn367_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn371_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn371_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn380_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn380_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn381_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn381_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn382_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn382_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn467_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn467_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn471_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn471_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn472_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn472_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn480_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn480_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn481_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn481_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn482_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn482_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn65_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn65_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn66_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn66_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn67_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn67_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn68_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn68_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn69_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn69_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn70_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn70_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn80_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn80_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn81_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn81_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Open_Parenthesis_kk_Fn82_CMD(Paper_Type As Integer, Test_Pattern As Integer) As Byte()

    ReDim ESC_POS_CMD(6) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Open_Parenthesis
    ESC_POS_CMD(2) = kk
    
    GS_Open_Parenthesis_kk_Fn82_CMD = ESC_POS_CMD
    
End Function

Public Function GS_P_CMD(X_Unit As Integer, Y_Unit As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = P
    ESC_POS_CMD(2) = X_Unit
    ESC_POS_CMD(3) = Y_Unit
    
    GS_P_CMD = ESC_POS_CMD
    
End Function

Public Function GS_T_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = T
    ESC_POS_CMD(2) = Mode
    
    GS_T_CMD = ESC_POS_CMD
    
End Function

Public Function GS_V_CMD(Mode As Integer, Motion_Unit As Integer) As Byte()
    
    If Mode = 49 Or Mode = 48 Or Mode = 1 Or Mode = 0 Then    'GS V Function A
        ReDim ESC_CMD(2) As Byte
        ESC_CMD(0) = GS
        ESC_CMD(1) = V
        ESC_CMD(2) = Mode
        
        GS_V_CMD = ESC_CMD
        
    Else
        ReDim ESC_CMD(3) As Byte                   'GS V Function B C D
        ESC_CMD(0) = GS
        ESC_CMD(1) = V
        ESC_CMD(2) = Mode
        ESC_CMD(3) = Motion_Unit
        GS_V_CMD = ESC_CMD
    End If

End Function

Public Function GS_W_CMD(L_Position As Integer, H_Position As Integer) As Byte()

    ReDim ESC_POS_CMD(3) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = W
    ESC_POS_CMD(2) = L_Position
    ESC_POS_CMD(3) = H_Position
    
    GS_W_CMD = ESC_POS_CMD
    
End Function

Public Function GS_aa_CMD(ByVal Mode As Integer) As Byte()
    
    ReDim ESC_POS_CMD(2) As Byte
    
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = aa
    ESC_POS_CMD(2) = Mode
    
    GS_aa_CMD = ESC_POS_CMD
    
End Function

Public Function GS_bb_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = bb
    ESC_POS_CMD(2) = Mode
    
    GS_bb_CMD = ESC_POS_CMD
    
End Function

Public Function GS_fff_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = fff
    ESC_POS_CMD(2) = Mode
    
    GS_fff_CMD = ESC_POS_CMD
    
End Function

Public Function GS_gg_Two_CMD(nL As Integer, nH As Integer) As Byte()

    ReDim ESC_POS_CMD(5) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = gg
    ESC_POS_CMD(2) = Two
    ESC_POS_CMD(3) = 0 'Null
    ESC_POS_CMD(4) = nL
    ESC_POS_CMD(5) = nH
    
    GS_gg_Two_CMD = ESC_POS_CMD
    
End Function

Public Function GS_gg_Zero_CMD(nL As Integer, nH As Integer) As Byte()

    ReDim ESC_POS_CMD(5) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = gg
    ESC_POS_CMD(2) = Zero
    ESC_POS_CMD(3) = 0 'Null
    ESC_POS_CMD(4) = nL
    ESC_POS_CMD(5) = nH
    
    GS_gg_Zero_CMD = ESC_POS_CMD
    
End Function

Public Function GS_hh_CMD(Height As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = hh
    ESC_POS_CMD(2) = Height
    
    GS_hh_CMD = ESC_POS_CMD
    
End Function

Public Function GS_kk_CMD(BarcodeType As Integer, BarCodeData As String) As Byte()

    Dim BarcodeLength As Integer
    Dim Counter As Integer
    
    BarcodeLength = LenB(StrConv(BarCodeData, vbFromUnicode))
    
    ReDim ESC_POS_CMD(BarcodeLength + 4) As Byte
    
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = kk
    ESC_POS_CMD(2) = BarcodeType
    ESC_POS_CMD(3) = BarcodeLength
    
    For Counter = 1 To BarcodeLength
    
        ESC_POS_CMD(3 + Counter) = AscB(MidB(StrConv(BarCodeData, vbFromUnicode), Counter, 1))
        
    Next Counter
    
    GS_kk_CMD = ESC_POS_CMD
    
End Function

Public Function GS_rr_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = rr
    ESC_POS_CMD(2) = Mode
    
    GS_rr_CMD = ESC_POS_CMD
    
End Function

Public Function GS_Slash_CMD(Mode As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = Slash
    ESC_POS_CMD(2) = Mode
    
    'ESC_POS_CMD(3) = H_Position
    
    GS_Slash_CMD = ESC_POS_CMD
    
End Function

Public Function GS_vv_Zero_CMD(Mode As Integer, XL As Byte, XH As Byte, YL As Byte, YH As Byte, BitMapData() As Byte) As Byte()

    Dim RetCodeayLength As Long
    Dim Counter As Long
    RetCodeayLength = UBound(BitMapData())
    
    ReDim ESC_POS_CMD(8 + RetCodeayLength) As Byte
    
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = vv
    ESC_POS_CMD(2) = Zero
    ESC_POS_CMD(3) = Mode
    ESC_POS_CMD(4) = XL
    ESC_POS_CMD(5) = XH
    ESC_POS_CMD(6) = YL
    ESC_POS_CMD(7) = YH
    
    For Counter = 0 To RetCodeayLength
    
        ESC_POS_CMD(8 + Counter) = BitMapData(Counter)
        
    Next Counter

    GS_vv_Zero_CMD = ESC_POS_CMD
    
End Function

Public Function GS_ww_CMD(Width As Integer) As Byte()

    ReDim ESC_POS_CMD(2) As Byte
    ESC_POS_CMD(0) = GS
    ESC_POS_CMD(1) = ww
    ESC_POS_CMD(2) = Width
    
    GS_ww_CMD = ESC_POS_CMD
    
End Function

Public Function HT_CMD() As Byte
    'Ver. 10.06 p.152
    'HT
    'EXECUTING Command
    '[Name] Horizontal tab
    '[Format]   ASCII   HT
    '           Hex     9
    '           Decimal 9
    '[Range] None
    '[Default] None
    '[Printers not featuring this command] None
    '[Description] Moves the print position to the next horizontal tab position.
    '[Notes]
    ' This command is ignored unless the next horizontal tab position has been set.
    ' Horizontal tab positions are set by ESC D.
    ' If the next horizontal tab position exceeds the print area, the printer sets the print position to [Print area width + 1].
    ' If this command is processed when the print position is at [Print area width + 1], the printer executes print
    '   buffer-full printing of the current line and horizontal tab processing from the beginning of the next line.
    '   In this case, in page mode, the printer does not execute printing, but the print position is moved.
    ' When underline mode is turned on, the underline will not be printed under the tab space skipped by this command.
    '[Model-dependent variations] None

    HT_CMD = HT

End Function

Public Function LF_CMD() As Byte
    'Ver. 10.06 p.66
    'LF
    'EXECUTING Command
    '[Name] Print and line feed
    '[Format]   ASCII   LF
    '           Hex     0A
    '           Decimal 10
    '[Range] None
    '[Default] None
    '[Printers not featuring this command] None
    '[Description] Prints the data in the print buffer and feeds one line, based on the current line spacing.
    '[Notes]
    ' The amount of paper fed per line is based on the value set using the line spacing command (ESC 2 or ESC 3).
    ' After printing, the print position moves to the beginning of the line. When a left margin is set in standard
    '   mode, the position of the left margin is the beginning of the line.
    ' When this command is processed in page mode, only the print position moves, and the printer does not perform actual printing.
    '[Model-dependent variations] TM - L90
    
    LF_CMD = LF

End Function

