Attribute VB_Name = "PRT_FUNCTION"

Public TM_Printer_Model As Integer

'*********************************
'*   Declare for Image
'*********************************
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (ByRef Ptr() As Any) As Long

Private Const BMP_DEFAULT As Long = 0

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function SafeArrayAllocDescriptor Lib "oleaut32.dll" (ByVal cDims As Long, ByRef ppsaOut As Long) As Long

'SAFEARRAY

Private Const FADF_AUTO As Long = (&H1)

Private Const FADF_FIXEDSIZE As Long = (&H10)

Public Type SAVEARRAY1D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    cElements As Long
    lLbound As Long
End Type

Public Enum FREE_IMAGE_FORMAT
    FIF_BMP = 0
End Enum

Public Enum FREE_IMAGE_LOAD_OPTIONS
    FILO_LOAD_DEFAULT = 0
End Enum

Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Declare Sub FreeImage_Initialise Lib "FreeImage.dll" Alias "_FreeImage_Initialise@4" (Optional ByVal LoadLocalPluginsOnly As Long)

Private Declare Sub FreeImage_DeInitialise Lib "FreeImage.dll" Alias "_FreeImage_DeInitialise@0" ()

Private Declare Function FreeImage_Load Lib "FreeImage.dll" Alias "_FreeImage_Load@12" (ByVal Format As FREE_IMAGE_FORMAT, ByVal FileName As String, Optional ByVal flags As FREE_IMAGE_LOAD_OPTIONS) As Long

Private Declare Sub FreeImage_Unload Lib "FreeImage.dll" Alias "_FreeImage_Unload@4" (ByVal BitMap As Long)

Private Declare Function FreeImage_GetWidth Lib "FreeImage.dll" Alias "_FreeImage_GetWidth@4" (ByVal BitMap As Long) As Long

Private Declare Function FreeImage_GetHeight Lib "FreeImage.dll" Alias "_FreeImage_GetHeight@4" (ByVal BitMap As Long) As Long

Private Declare Function FreeImage_GetDIBSize Lib "FreeImage.dll" Alias "_FreeImage_GetDIBSize@4" (ByVal BitMap As Long) As Long

Private Declare Function FreeImage_GetInfoHeader Lib "FreeImage.dll" Alias "_FreeImage_GetInfoHeader@4" (ByVal BitMap As Long) As Long

Private Declare Function FreeImage_GetInfo Lib "FreeImage.dll" Alias "_FreeImage_GetInfo@4" (ByVal BitMap As Long) As Long

Private Declare Function FreeImage_GetBits Lib "FreeImage.dll" Alias "_FreeImage_GetBits@4" (ByVal BitMap As Long) As Long

'---------------------------------------------------
'UTF8 sX/ѽX
'--------------------APIn--------------------
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Const CP_UTF8 = 65001


Public Function ASB(ByVal Mode As Integer) As Byte()
    
    If Mode > 1 Then Mode = 1
    If Mode < 0 Then Mode = 0
    
    ASB = GS_aa_CMD(Mode * 15)

End Function

Public Function ASB_Result(ASBCode() As Byte) As Integer()

    '=50    wL`
    '=30    L}
    '=20    Data is Cleared
    '=19    Buzzer Ұ
    '=18    Buzzer 
    '=17    CLҰ
    '=16    ǿҰ
    '=15    CL
    '
    '= 1    Ready and paper near end
    '= 0    Ready/M
    '=-1    Cover is open
    '=-2    Paper end (L)
    '=-3    Panel button pressed
    '=-4    Auto Cutter error
    '=-5    Unrecoverable error
    '=-6    Black mark Error(w)
    '=-7    No paper (3I,̥i)
    '=-8    ȱi
    '=-9    L\}Bq
    '=-10   Lu,ԤU@ӰT
    
    '=-90   q}QU
    '=-91   ACq_
    '=-41   CPU ~
    '=-42   OŪg~
    '=-43   hD}CŪg~
    '=-44   qL~
    '=-45   qLC~
    '=-46   qyL~
    '=-47   qG (BuzzerΨLu)
    '=-48   M~
    '=-49   \l}
    '=-50   ȱi榡~(¼Хw)
    '=-51   PYL
    '=-99   W~
  
    Dim Counter As Integer
    Dim ArraySize As Integer
    Dim ASBCounter As Integer
    Dim TempAry(100) As Integer
    Dim AryCounter As Integer
    Dim AL As Integer
  
    AryCounter = 0
    ArraySize = UBound(ASBCode())
    Counter = 0

    Do
        AryCounter = AryCounter + 1

        If ASBCode(Counter) = &H3B And ASBCode(Counter + 1) = &H30 And ASBCode(Counter + 2) = &H0 Then
    
            Counter = Counter + 3
            TempAry(AryCounter) = -998
        
        Else
    
            If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H22 And ASBCode(Counter + 2) = &H53 Then
    
                Counter = Counter + 7
                TempAry(AryCounter) = 17
                
            Else
            
                If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H22 And ASBCode(Counter + 2) = &H45 Then
    
                    Counter = Counter + 7
                    TempAry(AryCounter) = 15
        
                Else
                
                    If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H22 And ASBCode(Counter + 2) = &H21 Then
    
                        Counter = Counter + 7
                        TempAry(AryCounter) = 16
        
                    Else
                    
                        If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H22 And ASBCode(Counter + 2) = &H20 Then
                            
                            TempAry(AryCounter) = 10000 + (ASBCode(Counter + 3) - &H30) * 100 + (ASBCode(Counter + 4) - &H30) * 10 + (ASBCode(Counter + 5) - &H30)
                            Counter = Counter + 7
                        Else

                            If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H23 Then
    
                                Counter = Counter + 7
                                TempAry(AryCounter) = 50
        
                            Else
                        
                                If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H25 And ASBCode(Counter + 2) = &H0 Then
            
                                    Counter = Counter + 3
                                    TempAry(AryCounter) = 20
                            
                                Else

                                    If ASBCode(Counter) = &H3B And ASBCode(Counter + 1) = &H31 And ASBCode(Counter + 2) = &H0 Then
                                        
                                        Counter = Counter + 3
                                        TempAry(AryCounter) = 30
                                        
                                    Else
                            
                                        If ASBCode(Counter) = &H37 And ASBCode(Counter + 1) = &H52 Then
                                   
                                            Counter = Counter + 3
                                            TempAry(AryCounter) = 21
                                   
                                        Else

                                            If ASBCode(Counter) = &H18 And ASBCode(Counter + 1) = &H20 Then
                                    
                                                If ASBCode(Counter + 2) = &H0 Or ASBCode(Counter + 2) = &H3 Or ASBCode(Counter + 2) = &HC Or ASBCode(Counter + 2) = &HF Then
                        
                                                    TempAry(AryCounter) = -5
                        
                                                Else
                                    
                                                    TempAry(AryCounter) = -99
                                        
                                                End If
                                    
                                                Counter = Counter + 4
                                    
                                            Else

                                                If ASBCode(Counter) = &H10 Or ASBCode(Counter) = &H18 Or ASBCode(Counter) = &H38 Or ASBCode(Counter) = &H58 Or ASBCode(Counter) = &H1C Or ASBCode(Counter) = &H14 Or ASBCode(Counter) = &H3C Or ASBCode(Counter) = &H5C Then
                                            
                                                    Select Case ASBCode(Counter)

                                                        Case &H10, &H14
                                                    
                                                            Select Case ASBCode(Counter + 2)
                                                        
                                                                Case &H0
                                                                
                                                                    TempAry(AryCounter) = 0
                                                            
                                                                Case &H3, &H40, &H43, &H12
                                                                
                                                                    TempAry(AryCounter) = 1
                                                                
                                                                Case &H20, &H23, &H2F, &H2C
                                                                
                                                                    TempAry(AryCounter) = -7
                                                                
                                                                Case &HC, &HF

                                                                    TempAry(AryCounter) = -2
                                                            
                                                                Case Else
                                                                                                                                
                                                                    TempAry(AryCounter) = -99
                                                            
                                                            End Select
                                                    
                                                        Case &H18, &H1C
                                                        
                                                            Select Case ASBCode(Counter + 1)
                                                        
                                                                Case &H0
                                                                
                                                                    Select Case ASBCode(Counter + 2)
                                                                
                                                                        Case &H0
                                                                
                                                                            TempAry(AryCounter) = 19
                                                            
                                                                        Case &H2
                                                                    
                                                                            TempAry(AryCounter) = -3
                                                                        
                                                                        Case &HC
                                                                        
                                                                            TempAry(AryCounter) = -8
                                                                    
                                                                        Case &H3
                                                                
                                                                            TempAry(AryCounter) = -10
                                                                      
                                                                        Case &HF
                                                                    
                                                                            TempAry(AryCounter) = -2
                                                                        
                                                                        Case &H20, &H23
                                                                        
                                                                            TempAry(AryCounter) = -7
                                                                    
                                                                        Case &H2F, &H2C
                                                                    
                                                                            TempAry(AryCounter) = -9
                                                                    
                                                                        Case &H40, &H43, &H3
                                                                        
                                                                            TempAry(AryCounter) = 1

                                                                        Case &H24
                                                                        
                                                                            TempAry(AryCounter) = -9
                                                                    
                                                                        Case Else
                                                                        
                                                                            TempAry(AryCounter) = -10
                                                                        
                                                                    End Select
                                                            
                                                                Case &H2
                                                            
                                                                    TempAry(AryCounter) = -3
                                                                
                                                                Case &H4
                                                            
                                                                    If ASBCode(Counter + 2) = &H20 Or ASBCode(Counter + 2) = &H23 Or ASBCode(Counter + 2) = &H2C Or ASBCode(Counter + 2) = &H2F Then
                                                                        If ASBCode(Counter + 2) = &H2C Or ASBCode(Counter + 2) = &H2F Then
                                                                        
                                                                            TempAry(AryCounter) = 92
                                                                       
                                                                        Else

                                                                            If ASBCode(Counter + 2) = &H23 Then
                                                                            
                                                                                TempAry(AryCounter) = -30
                                                                            
                                                                            Else
                                                                            
                                                                                TempAry(AryCounter) = -2
                                                                            
                                                                            End If
                                                                        End If

                                                                    Else
                                                                                                                                        
                                                                        TempAry(AryCounter) = -6
                                                                    
                                                                    End If
                                                            
                                                                Case &H8
                                                                
                                                                    TempAry(AryCounter) = -4

                                                                Case &H20
                                                                
                                                                    TempAry(AryCounter) = -5

                                                                Case &H40
                                                                
                                                                    TempAry(AryCounter) = -12
                                                            
                                                                Case &H24
                                                            
                                                                    TempAry(AryCounter) = -9
                                                            
                                                                Case Else
                                                                
                                                                    TempAry(AryCounter) = -99
                                                                
                                                            End Select
                                                    
                                                        Case &H38, &H3C
                                                        
                                                            If ASBCode(Counter + 1) = &H20 Then
                                                            
                                                                TempAry(AryCounter) = -9
                                                            Else
                                                            
                                                                TempAry(AryCounter) = -1
                                                                
                                                            End If

                                                        Case &H58, &H5C
                                                            
                                                            TempAry(AryCounter) = -3
                                                    
                                                        Case Else
                                                                
                                                            TempAry(AryCounter) = -99
                                                    End Select
                                                
                                                    Counter = Counter + 4
                                                Else
                                        
                                                    TempAry(AryCounter) = -99
                                                    Counter = ArraySize + 1
                                        
                                                End If
                                    
                                            End If
                                        End If
                                    
                                    End If
                                
                                End If
                            
                            End If
                        
                        End If
                        
                    End If
                
                End If
                    
            End If
    
        End If
        
    Loop While Counter < ArraySize

    ReDim ASBCode1(AryCounter - 1) As Integer
    
    For Counter = 0 To AryCounter - 1
    
        ASBCode1(Counter) = TempAry(Counter + 1)
        
    Next Counter
    
    ASB_Result = ASBCode1
    
End Function

Private Function Add_Array(ByRef Source1() As Byte, ByRef Source2() As Byte) As Byte()
    Dim S1 As Long
    Dim S2 As Long
    Dim SL As Long
    
    S1 = UBound(Source1())
    S2 = UBound(Source2())
    
    ReDim ESC_POS_CMD(S1 + S2 + 1) As Byte
    
    For SL = 0 To S1
        ESC_POS_CMD(SL) = Source1(SL)
    Next SL
    
    For SL = 0 To S2
        ESC_POS_CMD(SL + S1 + 1) = Source2(SL)
    Next SL
    
    Add_Array = ESC_POS_CMD

End Function

Public Function BarCode(Row As Integer, Col As Integer, BarcodeType As Integer, Width As Integer, Height As Integer, HRI As Integer, FontType As Integer, PrintData As String, LineSpace As Integer, CharSpace As Integer, OffSet As Integer) As Byte()
    
    Dim BarcodeLength As Integer
    Dim Counter As Integer
    Dim Target() As Byte
    Dim BarCodeHeight As Integer
    
    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    If Row < 0 Then Row = 0
    If Row > 24 Then Row = 24
    If Col < 0 Then Col = 0
    If Col > 139 Then Col = 139
    If Height < 1 Then Height = 1
    If Height > 31 Then Height = 31
    If Width < 1 Then Width = 1
    If Width > 8 Then Width = 8
    If BarcodeType < 0 Then BarcodeType = 0
    If BarcodeType > 13 Then BarcodeType = 13
    
    BarCodeHeight = Height * 8
    BarcodeType = BarcodeType + 65
    
    Target = Add_Array(Locate(Row, Col, LineSpace, CharSpace, OffSet), GS_H_CMD(HRI))
    Target = Add_Array(Target, GS_fff_CMD(FontType))
    Target = Add_Array(Target, GS_hh_CMD(BarCodeHeight))
    Target = Add_Array(Target, GS_ww_CMD(Width))
    Target = Add_Array(Target, GS_kk_CMD(BarcodeType, PrintData))

    BarCode = Target
    
End Function

Public Function CashDrawer(ByVal Mode As Integer, ByVal Pin As Integer, ByVal Tick1 As Integer, ByVal Tick2 As Integer) As Byte()

    If Pin >= 2 Then Pin = 1
    If Pin <= 1 Then Pin = 0
    
    If Mode = 0 Then
    
        If Tick1 < 0 Then Tick1 = 1
        If Tick1 > 8 Then Tick1 = 8
        
        CashDrawer = DLE_DC4_FN1_CMD(Pin, Tick1)
    
    Else
    
        If Tick1 < 0 Then Tick1 = 0
        If Tick1 > 255 Then Tick1 = 255
        If Tick2 < 0 Then Tick2 = 0
        If Tick2 > 255 Then Tick2 = 255
        
        CashDrawer = ESC_pp_CMD(Pin, Tick1, Tick2)
          
    End If

End Function

Public Function ClearBuffer() As Byte()

    ClearBuffer = DLE_DC4_FN8_CMD
    
End Function

Public Function ClearError(ByVal Mode As Integer) As Byte()

    ClearError = DLE_ENQ_CMD(Mode)
    
End Function

Public Function Cut(Mode As Integer) As Byte()

    If Mode = 0 Then
        Cut = GS_V_CMD(65, 0)
    Else
        Cut = GS_V_CMD(49, 0)
    End If
    
End Function

Public Function Del_All_Logo() As Byte()
   
    Del_All_Logo = GS_Open_Parenthesis_L_Fn65_CMD

End Function

Public Function Del_Logo(ByVal KeyCode1 As Integer, ByVal KeyCode2 As Integer) As Byte()

    If KeyCode1 < 32 Then KeyCode1 = 32
    If KeyCode2 < 32 Then KeyCode1 = 32
    If KeyCode1 > 126 Then KeyCode1 = 126
    If KeyCode1 > 126 Then KeyCode1 = 126
    
    Del_Logo = GS_Open_Parenthesis_L_Fn66_CMD(KeyCode1, KeyCode2)

End Function

Public Sub Delay(ByVal MSec As Single)
    Dim sgnThisTime As Single, sgnCount As Single
    sgnThisTime = Timer

    Do While sgnCount < MSec
        sgnCount = (Timer - sgnThisTime) * 1000

        DoEvents
    Loop

End Sub

Private Function FreeImage_GetBitsEx(ByVal BitMap As Long) As Byte()
    Dim tSA As SAVEARRAY1D
    Dim lpSA As Long

    If (BitMap) Then

        With tSA
            .cbElements = 1                                ' size in bytes per array element
            .cDims = 1                                     ' the array has 2 dimensions
            .cElements = FreeImage_GetDIBSize(BitMap) - 48 ' the number of elements in y direction (height of Bitmap)
            .fFeatures = FADF_AUTO Or FADF_FIXEDSIZE       ' need AUTO and FIXEDSIZE for safety issues,
            ' so the array can not be modified in size
            ' or erased; according to Matthew Curland never
            ' use FIXEDSIZE alone
            .pvData = FreeImage_GetBits(BitMap)            ' let the array point to the memory block, the
            ' FreeImage scanline data pointer points to
        End With

        Call SafeArrayAllocDescriptor(2, lpSA)
        Call CopyMemory(ByVal lpSA, tSA, Len(tSA))
        Call CopyMemory(ByVal VarPtrArray(FreeImage_GetBitsEx), lpSA, 4)
    End If

End Function

Private Function FreeImage_GetInfoHeaderEx(ByVal BitMap As Long) As BITMAPINFOHEADER
    Dim lpInfoHeader As Long
    lpInfoHeader = FreeImage_GetInfoHeader(BitMap)

    If (lpInfoHeader) Then
        Call CopyMemory(FreeImage_GetInfoHeaderEx, ByVal lpInfoHeader, LenB(FreeImage_GetInfoHeaderEx))
    End If

End Function

Function GetASBName(Index As Integer) As String

    '=50    wL`
    '=20    Data is Cleared
    '=19    Buzzer Ұ
    '=18    Buzzer 
    '=17    CLҰ
    '=16    ǿҰ
    '=15    CL
    '= 2    qTREADY
    '= 1    Ready and paper near end
    '= 0    Ready/M
    '=-1    Cover is open
    '=-2    Paper end (L)
    '=-3    Panel button pressed
    '=-4    Auto Cutter error
    '=-5    Unrecoverable error
    '=-6    Black mark Error(w)
    '=-7    No paper (3I,̥i)
    '=-8    ȱi
    '=-9
    '=-10   Lu,ԤU@ӰT
    
    Select Case Index
    
        Case Is > 10000
            GetASBName = "wCLܲ" + Str(Index - 10000) + "i"
            
        Case 30
            GetASBName = "Lq}Ҩósu"
        
        Case 20
            GetASBName = "ƤwQM"
            
        Case 19
            GetASBName = "Buzzer Ұ"
             
        Case 18
            GetASBName = "Buzzer "
             
        Case 17
            GetASBName = "CLҰ"
            
        Case 16
            GetASBName = "ǿҰ"
            
        Case 15
            GetASBName = "CL"
            
        Case 2
            GetASBName = "Ls}, Ready"
            
        Case 1
            GetASBName = "ȱiYNκ"
            
        Case 0
            GetASBName = "L Ready for Print"
            
        Case -1
            GetASBName = "L\Q}"
            
        Case -2
            GetASBName = "ȱiκ,и˯"
             
        Case -3
            GetASBName = "eQU"
             
        Case -4
            GetASBName = "MG"
            
        Case -5
            GetASBName = "]ƬG,iOdȩΰFG٩ιqQ"
            
        Case -6
            GetASBName = "¼Хw"
            
        Case -7
            GetASBName = "ȱiwO̫@i"
            
        Case -8
            GetASBName = "ȱi,Эs˯"
            
        Case -9
            GetASBName = "\l},BiOFG٩ιqQ"
            
        Case -999
            GetASBName = "qHO,L^,ˬdqαu"
            
    End Select

End Function

Private Function GetBit(ByVal num As Integer, ByVal Index As Integer) As Integer
    GetBit = (num And (2 ^ Index)) / (2 ^ Index)
End Function

Public Function GetData_Result(DataCode() As Byte) As String

    Dim ArraySize As Integer
    Dim Counter As Integer
    Dim DString As String
    Dim X As Integer
    
    ArraySize = UBound(DataCode())
    X = 0
    
LX:
    
    If DataCode(X) = &H5F And DataCode(ArraySize) = &H0 Then
    
        For Counter = X + 1 To ArraySize - 1
    
            DString = DString + Chr(DataCode(Counter))
            
        Next Counter
        
        GetData_Result = DString
        
    Else
    
        If DataCode(X) = &H14 Or DataCode(X) = &H1C Or DataCode(X) = &H3C Then
        
            X = X + 4
            
            If X > ArraySize Then
                    
                GetData_Result = ""
            Else
            
                GoTo LX
                
            End If
            
        End If
        
    End If

End Function

Public Function Get_Cut_Times() As Byte()

    Get_Cut_Times = GS_gg_Two_CMD(50, 0)
    
End Function

Public Function Get_Cut_Times_Cum() As Byte()

    Get_Cut_Times_Cum = GS_gg_Two_CMD(178, 0)
    
End Function

Public Function Get_FeedLine() As Byte()

    Get_FeedLine = GS_gg_Two_CMD(20, 0)
    
End Function

Public Function Get_FeedLine_Cum() As Byte()

    Get_FeedLine_Cum = GS_gg_Two_CMD(148, 0)
    
End Function

Public Function Get_Firmware_Version() As Byte()

    Get_Firmware_Version = GS_I_CMD(65)
    
End Function

Public Function Get_HeadStroke() As Byte()

    Get_HeadStroke = GS_gg_Two_CMD(21, 0)
    
End Function

Public Function Get_HeadStroke_Cum() As Byte()

    Get_HeadStroke_Cum = GS_gg_Two_CMD(149, 0)
    
End Function

Public Function Get_MemSwitch(ByVal MemSW As Integer) As Byte()

    Get_MemSwitch = GS_Open_Parenthesis_E_Fn4_CMD(MemSW)
    
End Function

Public Function Get_Printer_Model() As Byte()

    Get_Printer_Model = GS_I_CMD(67)
    
End Function

Public Function Get_Printer_Op_Hours() As Byte()

    Get_Printer_Op_Hours = GS_gg_Two_CMD(70, 0)
    
End Function
Public Function Transmit_PrinterID(Fn As Integer) As Byte()

    Transmit_PrinterID = GS_I_CMD(Fn)
    
End Function

Public Function Get_Printer_Op_Hours_Cum() As Byte()

    Get_Printer_Op_Hours_Cum = GS_gg_Two_CMD(198, 0)
    
End Function

Public Function Get_SerialNo() As Byte()

    Get_SerialNo = GS_I_CMD(68)
    
End Function

Public Function Initial() As Byte()

    Initial = ESC_AT_CMD
    
End Function

Private Sub LoadBMP_FS(ByVal picName As String, ByRef XLH() As Byte, ByRef YLH() As Byte, ByRef ESC_BitMap() As Byte)
    Dim BMPInfo As BITMAPINFOHEADER   ' 40 bytes
    Dim dw As Integer
    Dim dib As Long
    ReDim XLH(1)
    ReDim YLH(1)
    Dim BMData() As Byte
    Dim I, J, M As Integer
    Dim T, U, L, H, K, Z, X, Y, W  As Long
    Dim ix As Integer
    ' picName = StrConv(picName, vbUnicode)
    dib = FreeImage_Load(0, picName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    L = (FreeImage_GetDIBSize(dib) - 48) / BMPInfo.biHeight
    T = Int((BMPInfo.biWidth + 7) / 8)
    U = BMPInfo.biWidth Mod 8
    H = Int((BMPInfo.biHeight + 7) / 8)

    If U = 0 Then U = 8

    For I = 1 To U
        dw = dw + 2 ^ (8 - I)
    Next I

    XLH(0) = T Mod 256                            'xL
    XLH(1) = Int(T / 256)                         'xH
    YLH(0) = H Mod 256                            'yL
    YLH(1) = Int(H / 256)                         'yH
    ReDim BMData(FreeImage_GetDIBSize(dib) - 49) As Byte
    ReDim ESC_BITTEMP(H * T * 8 - 1) As Byte
    ReDim ESC_BitMap(H * T * 8 - 1) As Byte
    BMData = FreeImage_GetBitsEx(dib)

    For Y = BMPInfo.biHeight To 1 Step -1
        For X = 1 To T
            W = (Y - 1) * L + X - 1

            If Z <> 0 And (((Z + 1) Mod T) = 0) Then
                ESC_BITTEMP(Z) = BMData(W) Xor dw
            Else
                ESC_BITTEMP(Z) = Not BMData(W)
                '
            End If

            Z = Z + 1
        Next X
    Next Y

    L = 0
    dw = 0

    For X = 0 To (T - 1)
        For ix = 7 To 0 Step -1
            For Y = 0 To (H - 1)
                For Z = 0 To 7
                    K = (8 * Y + Z) * T + X
                    dw = dw + GetBit(Val(ESC_BITTEMP(K)), ix) * (2 ^ (7 - Z))
                Next Z

                ESC_BitMap(L) = dw
                L = L + 1
                dw = 0
            Next Y
        Next ix
    Next X

End Sub

Private Sub LoadBMP_GS(ByVal picName As String, ByRef XLH() As Byte, ByRef YLH() As Byte, ByRef ESC_BitMap() As Byte)
    Dim BMPInfo As BITMAPINFOHEADER   ' 40 bytes
    Dim dw As Integer
    Dim dib As Long
    ReDim XLH(1)
    ReDim YLH(1)
    Dim BMData() As Byte
    Dim I, J, M As Integer
    Dim T, U, L, H, K, Z, X, Y, W  As Long
    Dim ix As Integer
    ' picName = StrConv(picName, vbUnicode)
    dib = FreeImage_Load(0, picName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    
    L = (FreeImage_GetDIBSize(dib) - 48) / BMPInfo.biHeight
    T = Int((BMPInfo.biWidth + 7) / 8)
    
    U = BMPInfo.biWidth Mod 8
    H = Int((BMPInfo.biHeight + 7) / 8)

    If U = 0 Then U = 8

    For I = 1 To U
        dw = dw + 2 ^ (8 - I)
    Next I

    XLH(0) = T Mod 256                            'xL
    XLH(1) = Int(T / 256)                         'xH
    YLH(0) = H Mod 256                            'yL
    YLH(1) = Int(H / 256)                         'yH
    
    ReDim BMData(FreeImage_GetDIBSize(dib) - 49) As Byte
    ReDim ESC_BITTEMP(H * T * 8 - 1) As Byte
    ReDim ESC_BitMap(H * T * 8 - 1) As Byte
    BMData = FreeImage_GetBitsEx(dib)

    For Y = BMPInfo.biHeight To 1 Step -1
        For X = 1 To T
            W = (Y - 1) * L + X - 1

            If Z <> 0 And (((Z + 1) Mod T) = 0) Then
                ESC_BITTEMP(Z) = BMData(W) Xor dw
            Else
                ESC_BITTEMP(Z) = Not BMData(W)
                '
            End If

            Z = Z + 1
        Next X
    Next Y

    L = 0
    dw = 0

    For X = 0 To (T - 1)
        For ix = 7 To 0 Step -1
            For Y = 0 To (H - 1)
                For Z = 0 To 7
                    K = (8 * Y + Z) * T + X
                    dw = dw + GetBit(Val(ESC_BITTEMP(K)), ix) * (2 ^ (7 - Z))
                Next Z

                ESC_BitMap(L) = dw
                L = L + 1
                dw = 0
            Next Y
        Next ix
    Next X

End Sub

Private Sub LoadBMP_GS_v_0(ByVal picName As String, ByRef P14() As Byte, ByRef XLH() As Byte, ByRef YLH() As Byte, ByRef ESC_BitMap() As Byte)
    
    Dim dw As Integer
    Dim BMPInfo As BITMAPINFOHEADER
    Dim I, J As Integer
    Dim dib As Long
    ReDim XLH(1)
    ReDim YLH(1)
    ReDim P14(3)
    Dim BMData() As Byte
    Dim T, U, L, H, K, Z, X, Y, W  As Long
    '   picName = StrConv(picName, vbUnicode)
    dib = FreeImage_Load(0, picName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    L = (FreeImage_GetDIBSize(dib) - 48) / BMPInfo.biHeight
    T = Int((BMPInfo.biWidth + 7) / 8)
    U = BMPInfo.biWidth Mod 8

    If U = 0 Then U = 8

    For I = 1 To U
        dw = dw + 2 ^ (8 - I)
    Next I

    W = T * BMPInfo.biHeight + 11         'for P1~P4      Dx*Dy = bitmap for EPSON   11= m + fn + a + kc1 + kc2 + b + xL +xH + yL +yH + c  TOTAL 11 BYTES
    '
    P14(0) = W Mod 256                            'P1  = pL
    P14(1) = (Int(W / 256) Mod 256)               'P2  = pH
    P14(2) = Int(W / 65536)                       'P3
    P14(3) = Int(W / 16777216)                    'P4
    XLH(0) = BMPInfo.biWidth Mod 256        'xL
    XLH(1) = Int(BMPInfo.biWidth / 256)     'xH
    YLH(0) = BMPInfo.biHeight Mod 256       'yL
    YLH(1) = Int(BMPInfo.biHeight / 256)    'yH
    ReDim BMData(FreeImage_GetDIBSize(dib) - 49) As Byte
    BMData = FreeImage_GetBitsEx(dib)
    ' W = T * BMPInfo.biHeight - 1
    ReDim ESC_BitMap(T * BMPInfo.biHeight - 1) As Byte

    For Y = BMPInfo.biHeight To 1 Step -1
        For X = 1 To T
            W = (Y - 1) * L + X - 1

            If Z <> 0 And (((Z + 1) Mod T) = 0) Then
                ESC_BitMap(Z) = BMData(W) Xor dw
            Else
                '
                ESC_BitMap(Z) = Not BMData(W)
            End If

            Z = Z + 1
        Next X
    Next Y

End Sub

Public Function Load_BitMap_GS_L(Row As Integer, Col As Integer, ByVal FileName As String, ByVal X2 As Integer, ByVal Y2 As Integer) As Byte() 'GS 8 L
    
    Dim dib As Long
    Dim BMPInfo As BITMAPINFOHEADER
    dib = FreeImage_Load(0, FileName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    Dim Target() As Byte
    Dim XLH() As Byte
    Dim YLH() As Byte
    Dim P14() As Byte
    Dim ESC_BitMap() As Byte
    
    Call LoadBMP_GS_v_0(FileName, P14(), XLH(), YLH(), ESC_BitMap())
    
    Target = GS_Eight_L_Fn112_CMD(P14(), X2, Y2, XLH(0), XLH(1), YLH(0), YLH(1), ESC_BitMap())
    
    Load_BitMap_GS_L = Target
    
End Function

Private Function Locate(ByVal Row As Integer, ByVal Col As Integer, ByVal LineSpace As Integer, ByVal CharSpace As Integer, ByVal OffSet As Integer) As Byte()

    Dim Target() As Byte
    
    Dim DXL As Integer
    Dim DXH As Integer
    Dim DYL As Integer
    Dim DYH As Integer

    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    
    DYL = (Col * (12 + CharSpace)) Mod 256
    DYH = Int((Col * (12 + CharSpace)) / 256)
    
    If (Row + 1) * (24 + LineSpace) + OffSet > 0 Then
        DXL = ((Row + 1) * (24 + LineSpace) + OffSet) Mod 256
        DXH = Int(((Row + 1) * (24 + LineSpace) + OffSet) / 256)
    Else
        Row = 4
        DXL = ((Row + 1) * (24 + LineSpace) + OffSet) Mod 256
        DXH = Int(((Row + 1) * (24 + LineSpace) + OffSet) / 256)
    End If
    
    Target = Add_Array(GS_Dollar_Sign_CMD(DXL, DXH), ESC_Dollar_Sign_CMD(DYL, DYH))
    
    Locate = Target

End Function

Private Function Locate_BMP(ByVal Y As Integer, ByVal X As Integer, ByVal picName As String, ByVal LineSpace As Integer, ByVal CharSpace As Integer, ByVal OffSet As Integer) As Byte()
    Dim X1, X2, Y1, Y2 As Integer
    ReDim ESC_CMD(7) As Byte
    Dim BMPInfo As BITMAPINFOHEADER
    Dim dib As Long

    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    dib = FreeImage_Load(0, picName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    X1 = ((X) * (12 + CharSpace)) Mod 256
    X2 = Int(((X) * (12 + CharSpace)) / 256)
    ESC_CMD(0) = 27
    ESC_CMD(1) = 36
    ESC_CMD(2) = X1
    ESC_CMD(3) = X2
    'Y1 = ((Y + 1) * (24 + LineSpace) + BMPInfo.biHeight) Mod 256
    'Y2 = Int(((Y + 1) * (24 + LineSpace) + BMPInfo.biHeight) / 256)
    Y1 = ((Y + 1) * (24 + LineSpace) + OffSet) Mod 256
    Y2 = Int(((Y + 1) * (24 + LineSpace) + OffSet) / 256)
    ESC_CMD(4) = 29
    ESC_CMD(5) = 36
    ESC_CMD(6) = Y1
    ESC_CMD(7) = Y2
    Locate_BMP = ESC_CMD
    
End Function

'Private Function Locate_Prn(ByVal Row As Integer, ByVal Col As Integer) As Byte()
'
'    Dim Target() As Byte
'
'    Dim DXL As Integer
'    Dim DXH As Integer
'    Dim DYL As Integer
'    Dim DYH As Integer
'
'    DYL = (Col * 12) Mod 256
'    DYH = Int((Col * 12) / 256)
'
'    'DXL = ((Row + 1) * 28) Mod 256
'    'DXH = Int(((Row + 1) * 28) / 256)
'
'    DXL = ((Row + 1) * 24 * 2) Mod 256
'    DXH = Int(((Row + 1) * 24 * 2) / 256)
'
'    Target = Add_Array(GS_Dollar_Sign_CMD(DXL, DXH), ESC_Dollar_Sign_CMD(DYL, DYH))
'
'    Locate_Prn = Target
'
'End Function

Private Function Locate_Prn(ByVal Row As Integer, ByVal Col As Integer, ByVal LineSpace As Integer, ByVal CharSpace As Integer) As Byte()

    Dim Target() As Byte
    
    Dim DXL As Integer
    Dim DXH As Integer
    Dim DYL As Integer
    Dim DYH As Integer
    
    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    
    DYL = (Col * (12 + CharSpace)) Mod 256
    DYH = Int((Col * (12 + CharSpace)) / 256)
    
    DXL = ((Row + 1) * (24 + LineSpace)) Mod 256
    DXH = Int(((Row + 1) * (24 + LineSpace)) / 256)
    
    Target = Add_Array(GS_Dollar_Sign_CMD(DXL, DXH), ESC_Dollar_Sign_CMD(DYL, DYH))
    
    Locate_Prn = Target

End Function

Public Function PagePrint() As Byte

    PagePrint = FF_CMD

    Debug.Print PagePrint
    
End Function

Public Function Page_Layout(ByVal Width As Integer, ByVal Length As Single, ByVal Direction As Integer) As Byte()

    If Width > 76 Then Width = 76
    If Width < 0 Then Width = 0
    If Length > 210 Then Length = 210
    If Length < 0 Then Length = 0
    If Direction > 3 Then Direction = 3
    If Direction < 0 Then Direction = 0
    
    Dim Target() As Byte
    Dim DXL As Integer
    Dim DXH As Integer
    Dim DYL As Integer
    Dim DYH As Integer
    DXL = (Width * 8) Mod 256
    DXH = Int((Width * 8) / 256)
    
    'MsgBox TM_Printer_Model
    
    If TM_Printer_Model = 1 Then
        DYL = (Length * 16) Mod 256   'T82II
        DYH = Int((Length * 16) / 256)
    Else
        DYL = (Length * 8) Mod 256
        DYH = Int((Length * 8) / 256)
        '
    End If

    Target = Add_Array(ESC_L_CMD(), GS_P_CMD(0, 203))
    Target = Add_Array(Target, ESC_W_CMD(0, 0, 0, 0, DXL, DXH, DYL, DYH))
    Target = Add_Array(Target, ESC_T_CMD(Direction))
    Page_Layout = Target
End Function

Public Function Panel_Button(Mode As Integer) As Byte()

    If Mode > 1 Then Mode = 1
    If Mode < 0 Then Mode = 0
    
    Panel_Button = ESC_cc_Five_CMD(1 - Mode)
    
End Function

Public Function PrintBMP(Row As Integer, Col As Integer, FileName As String, ByVal Mode As Integer, ByVal LineSpace As Integer, ByVal CharSpace As Integer, ByVal OffSet As Integer) As Byte()
    
    Dim XLH() As Byte
    Dim YLH() As Byte

    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    Dim BitMap() As Byte
    Dim Target() As Byte
    Call LoadBMP_FS(FileName, XLH(), YLH(), BitMap())
    Target = Add_Array(Locate_BMP(Row, Col, FileName, LineSpace, CharSpace, OffSet), GS_Asterisk_CMD(XLH(0), YLH(0), BitMap()))
    'Target = Add_Array(Locate(Row, Col, FileName, LineSpace, CharSpace, OffSet), GS_Asterisk_CMD(XLH(0), YLH(0), BitMap()))
    
    Target = Add_Array(Target, GS_Slash_CMD(Mode))
    PrintBMP = Target
    
End Function

Public Function Print_BitMap_GS_L() As Byte() 'GS 8 L
   
    Print_BitMap_GS_L = GS_Open_Parenthesis_L_Fn50_CMD
    
End Function

Public Function Print_BitMap_GS_v(Row As Integer, Col As Integer, ByVal FileName As String, ByVal X As Integer, LineSpace As Integer, OffSet As Integer) As Byte()

    Dim dib As Long
    Dim BMPInfo As BITMAPINFOHEADER
    dib = FreeImage_Load(0, FileName, 0)
    BMPInfo = FreeImage_GetInfoHeaderEx(dib)
    '
    '   If (Row * 24 + BMPInfo.biHeight) > 432 Then E_Prt_BMP = -5
    '   If (Col * 12 + BMPInfo.biWidth) > 1680 Then E_Prt_BMP = -6
    Dim Target() As Byte
    Dim XLH() As Byte
    Dim YLH() As Byte
    Dim P14() As Byte
    Dim ESC_BitMap() As Byte
    'Dim l As Long
    'Dim i As Integer
    Dim X1, X2, Y1, Y2 As Integer
    '
    Call LoadBMP_GS_v_0(FileName, P14(), XLH(), YLH(), ESC_BitMap())
 
    Target = Add_Array(Locate(Row, Col, LineSpace, CharSpace, OffSet), GS_vv_Zero_CMD(X, XLH(0), XLH(1), YLH(0), YLH(1), ESC_BitMap()))
    '   '
    Print_BitMap_GS_v = Target
    
End Function

Public Function Print_NV_Data(Row As Integer, Col As Integer, KeyCode1 As Integer, KeyCode2 As Integer, Width As Integer, Height As Integer, LineSpace As Integer, CharSpace As Integer, OffSet As Integer)
    
    Dim Target() As Byte
    
    Target = Add_Array(Locate(Row, Col, LineSpace, CharSpace, OffSet), GS_Open_Parenthesis_L_Fn69_CMD(KeyCode1, KeyCode2, Width, Height))
    Print_NV_Data = Target
    
End Function

Public Function Real_Time_Cmd(Mode As Integer, On_Off As Integer) As Byte()

    Real_Time_Cmd = GS_Open_Parenthesis_D_CMD(Mode, On_Off)

End Function

Public Function QRCode(ByVal Row As Integer, ByVal Col As Integer, ByVal PrintData As String, ByVal EC_Level As Integer, ByVal QRSize As Integer, ByVal QRModel As Integer, ByVal LineSpace As Integer, ByVal CharSpace As Integer, ByVal OffSet As Integer, ByVal QRCode_InternalCode As Integer) As Byte()
 
    Dim Target() As Byte
    Dim fByte() As Byte
    Dim Counter As Integer
    
    'If Row < 0 Then Row = 0
    'If Row > 24 Then Row = 24
    'If Col < 0 Then Col = 0
    'If Col > 139 Then Col = 139
    'If LineSpace > 24 Then LineSpace = 24
    
    If LineSpace < 0 Then LineSpace = 0
    
    If QRCode_InternalCode = 0 Then   'Big5
        
        QRLength = LenB(StrConv(PrintData, vbFromUnicode))
        ReDim fByte(QRLength - 1) As Byte
        
        For Counter = 0 To QRLength - 1
        
            fByte(Counter) = AscB(MidB(StrConv(PrintData, vbFromUnicode), Counter + 1, 1))
            
        Next Counter

        
    Else
    
        fByte = UTF8_Encode(PrintData)
    
    End If
    
    
    
    Target = Add_Array(Locate(Row, Col, LineSpace, CharSpace, OffSet), GS_Open_Parenthesis_kk_Fn165_CMD(QRModel))
    
    
    Target = Add_Array(Target, GS_Open_Parenthesis_kk_Fn167_CMD(QRSize))
    Target = Add_Array(Target, GS_Open_Parenthesis_kk_Fn169_CMD(EC_Level))
    
    Target = Add_Array(Target, GS_Open_Parenthesis_kk_Fn180_CMD(fByte))
    
    Target = Add_Array(Target, GS_Open_Parenthesis_kk_Fn181_CMD())
   
    QRCode = Target
       
End Function

Public Function Query_Printer_Status(ByVal Mode As Integer) As Byte()

    Query_Printer_Status = DLE_EOT_CMD(Mode)

End Function

Public Function Query_Result(ByRef RetCode() As Byte) As Integer()
    ReDim ESC_CMD(1) As Integer
    
    'ESC_CMD(0)
    '= 1 Ready and paper near end
    '= 0 Ready
    '=-1 Cover is open
    '=-2 Paper end (L)
    '=-3 Panel button pressed
    '=-4 Auto Cutter error
    '=-5 Unrecoverable error
    '=-6 Black mark Error(w)
    '=-7 No paper (3I,̥i)
    '=-8 ȱi
    '=-9 No paper (3I,̥i)BȱiΧ
    
    'ESC_CMD(1)
    '= 0 Drawer kick-out connector pin 3 is Low
    '= 1 Drawer kick-out connector pin 3 is High
    
    If (RetCode(0) And &H8) Then                 '<> 0 Off Line
    
        If (RetCode(0) And &H40) Then            '<>0 Panel Button Pressed
        
            ESC_CMD(0) = -3
            
        Else                                     '=0 Panel Button Not Pressed ,other error
            
            If (RetCode(1) And &H40) Then        '<>0 Error has occurred
            
                If (RetCode(2) And &H4) Then    '<>0 Mechanical error has occurred
                        
                    ESC_CMD(0) = -6
                
                Else
                
                    If (RetCode(2) And &H8) Then    '<>0 Mechanical error has occurred
                        
                        ESC_CMD(0) = -4
                    
                    Else
                        
                        If (RetCode(2) And &H20) Then    '<>0 Mechanical error has occurred
                            
                            ESC_CMD(0) = -5
                    
                        Else
                    
                            ESC_CMD(0) = -11
                            
                        End If
                        
                    End If
                
                End If

            Else                                '=0 Cover is Not Opened
                
                If (RetCode(1) And &H4) Then     '<>0 Panel Button Pressed
                
                    ESC_CMD(0) = -1
                
                Else                            '=0 Panel Button Not Pressed
                    
                    If (RetCode(1) And &H20) Then  '<>0 Paper End
                                                
                        If (RetCode(3) And &H4) Then
                            
                            If UBound(RetCode()) = 5 Then
                            
                                If (RetCode(4) And &H40) Then
                        
                                    ESC_CMD(0) = -9
                                Else
                                
                                    ESC_CMD(0) = -2
                                
                                End If
                            
                            Else
                                
                                ESC_CMD(0) = -2
                            
                            End If
                        
                        Else
                        
                            ESC_CMD(0) = -8
                            
                        End If

                    Else
                                    
                        If (RetCode(1) And &H8) Then    '<>0 button pressed
                            
                            ESC_CMD(0) = -3
                    
                        Else
                    
                            ESC_CMD(0) = -11
                            
                        End If
                        
                    End If
                    
                End If
                    
            End If
            
        End If

    Else                                        '=0 On Line
        
        If UBound(RetCode()) = 5 Then
            
            If (RetCode(4) And &H40) Then             '<> Last One
               
                ESC_CMD(0) = -7
                
            End If
            
        Else
            
            '=0 Paper not Near End
            
            If (RetCode(3) And &H4) Then
                
                ESC_CMD(0) = 1
                
            Else
            
                ESC_CMD(0) = 0
                
            End If
        
        End If
    
    End If
    
    If RetCode(0) And &H4 Then
    
        ESC_CMD(1) = 1  'Drawer kick-out connector pin 3 is High
        
    Else
    
        ESC_CMD(1) = 0  'Drawer kick-out connector pin 3 is Low
        
    End If
    
    Query_Result = ESC_CMD
    
End Function

Public Function Set_Counter(Fn As Integer) As Byte()
    ReDim ESC_CMD(2) As Byte
    Dim TempStr As String
    Dim D2, D3, D4 As Integer
     
    TempStr = Right$("000" + LTrim$(Str$(Fn)), 3)
    D2 = Asc(Mid$(TempStr, 1))
    D3 = Asc(Mid$(TempStr, 2))
    D4 = Asc(Mid$(TempStr, 3))
   
    Set_Counter = GS_Open_Parenthesis_H_Fn48_CMD(32, D2, D3, D4)
    
End Function

Public Sub Set_Printer_Model(ByVal PrinterModel As Integer)
    
    TM_Printer_Model = PrinterModel
    ' MsgBox TM_Printer_Model
End Sub

Public Function Set_ProcessID(Fn As Integer) As Byte()

    Dim ID1 As Integer
    Dim ID2 As Integer
    Dim ID3 As Integer
    Dim ID4 As Integer

    Select Case Fn

        Case 1  'ǿ}l
            ID1 = Asc("!")
            ID2 = Asc("T")
            ID3 = Asc("X")
            ID4 = Asc("!")

        Case 2   'CL}l
            ID1 = Asc("S")
            ID2 = Asc("T")
            ID3 = Asc("A")
            ID4 = Asc("R")

        Case 3  'CL
            ID1 = Asc("E")
            ID2 = Asc("N")
            ID3 = Asc("D")
            ID4 = Asc("!")

        Case Else
            ID1 = Asc("*")
            ID2 = Asc("N")
            ID3 = Asc("G")
            ID4 = Asc("*")
    End Select

    Set_ProcessID = GS_Open_Parenthesis_H_Fn48_CMD(ID1, ID2, ID3, ID4)
    
End Function
Public Function Printer_SelfTest(PaperType As Integer, Test_Pattern As Integer) As Byte()

    Printer_SelfTest = GS_Open_Parenthesis_A_CMD(PaperType, Test_Pattern)

End Function

Public Function Print_Feed_Dots(FeedLines_Unit As Integer) As Byte()

    If FeedLines_Unit > 255 Then FeedLines_Unit = 255
    If FeedLines_Unit < 0 Then FeedLines_Unit = 0
    
    Print_Feed_Dots = ESC_J_CMD(FeedLines_Unit)

End Function
Public Function Print_Feed_Lines(FeedLines As Integer) As Byte()

    If FeedLines > 255 Then FeedLines = 255
    If FeedLines < 0 Then FeedLines = 0
    
    Print_Feed_Lines = ESC_dd_CMD(FeedLines)

End Function

Public Function Set_Speed(Speed As Integer) As Byte()

    If Speed < 1 Then Speed = 1
    If Speed > 11 Then Speed = 11
    
    Set_Speed = GS_Open_Parenthesis_K_Fn50_CMD(Speed)

End Function

Public Function Set_Print_Density(Density As Integer) As Byte()

    If Density < 1 Then Speed = 1
    If Speed > 13 Then Speed = 13
    
    Set_Print_Density = GS_Open_Parenthesis_K_Fn49_CMD(Density)

End Function

Public Function TPrint(Row As Integer, Col As Integer, DoubleW As Integer, DoubleH As Integer, Emphasized As Integer, UnderLine As Integer, Smooth As Integer, Reverse As Integer, PrintData As String, LineSpace As Integer, CharSpace As Integer) As Byte()
    
    Dim Target() As Byte
    Dim Size As Integer
    Dim Str_length As Integer
    Dim Counter As Integer
    Str_length = LenB(StrConv(PrintData, vbFromUnicode))
    
    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    
    ReDim ESC_CMD(Str_length - 1) As Byte
    
    If DoubleW > 1 Or DoubleH > 1 Then
    
        'Target = Add_Array(Locate_Prn(Row, Col, LineSpace), ESC_E_CMD(Emphasized))
        
        Target = Add_Array(Locate_Prn(Row, Col, LineSpace, CharSpace), GS_bb_CMD(Smooth))
        
        Target = Add_Array(Target, ESC_E_CMD(Emphasized))
        Target = Add_Array(Target, GS_B_CMD(Reverse))
        
        Target = Add_Array(Target, ESC_Hyphen_CMD(UnderLine))
        Size = 1 * DoubleH + 16 * DoubleW
        Target = Add_Array(Target, GS_Exclamation_Point_CMD(Size))
        
        Target = Add_Array(Target, ESC_SP_CMD(CharSpace))

        For Counter = 1 To Str_length
            ESC_CMD(Counter - 1) = AscB(MidB(StrConv(PrintData, vbFromUnicode), Counter, 1))
        Next Counter
        
        Target = Add_Array(Target, ESC_CMD())

    Else
        
        Size = 1 * DoubleH + 16 * DoubleW
        
        Target = Add_Array(Locate_Prn(Row, Col, LineSpace, CharSpace), GS_bb_CMD(Smooth))
        Target = Add_Array(Target, GS_B_CMD(Reverse))
        Target = Add_Array(Target, GS_Exclamation_Point_CMD(Size))
        
        '   GS_bb_CMD
        Size = 8 * Emphasized + 16 * DoubleH + 32 * DoubleW + 128 * UnderLine
        Target = Add_Array(Target, ESC_Exclamation_Point_CMD(Size))

        Size = 4 * DoubleW + 8 * DoubleH + 128 * UnderLine
        Target = Add_Array(Target, FS_Exclamation_Point_CMD(Size))
        Target = Add_Array(Target, ESC_SP_CMD(CharSpace))

        For Counter = 1 To Str_length
            ESC_CMD(Counter - 1) = AscB(MidB(StrConv(PrintData, vbFromUnicode), Counter, 1))
        Next Counter
        
        Target = Add_Array(Target, ESC_CMD())

    End If
    
    TPrint = Target

End Function

Public Function Version() As String
    
    Version = Right$("  " + Trim$(Str$(App.Major)), 2) + "." + Right$("00" + Trim$(Str$(App.Minor)), 2)
    
End Function

Public Function FPrint(Row As Integer, Col As Integer, DoubleW As Integer, DoubleH As Integer, UnderLine As Integer, PrintData As String, LineSpace As Integer, CharSpace As Integer) As Byte()

    Dim Target() As Byte
    Dim Size As Integer
    Dim Str_length As Integer
    Dim Counter As Integer
    Str_length = LenB(StrConv(PrintData, vbFromUnicode))
    
    If LineSpace > 24 Then LineSpace = 24
    If LineSpace < 0 Then LineSpace = 0
    
    ReDim ESC_CMD(Str_length - 1) As Byte
    
    Target = Add_Array(Locate_Prn(Row, Col, LineSpace, CharSpace), GS_bb_CMD(1))
        
    Target = Add_Array(Target, FS_Ampersand_CMD)
        
    Target = Add_Array(Target, FS_Hyphen_CMD(UnderLine))
        
    Size = 4 * DoubleH + 8 * DoubleW + UnderLine * 128
        
    Target = Add_Array(Target, FS_S_CMD(CharSpace, CharSpace))
        
    Target = Add_Array(Target, FS_Exclamation_Point_CMD(Size))
        
    For Counter = 1 To Str_length
        
        ESC_CMD(Counter - 1) = AscB(MidB(StrConv(PrintData, vbFromUnicode), Counter, 1))
        
    Next Counter
        
    Target = Add_Array(Target, ESC_CMD())
    Target = Add_Array(Target, FS_Dot_CMD)
    
    FPrint = Target
    
End Function

Public Function Power_Off() As Byte()
    '    Dim Target() As Byte
    '
    '    Target = Add_Array(GS_OPEN_PARENTHESIS_D_CMD(2, 1), Initial)
    '    Target = Add_Array(Target, DLE_DC4_FN2_CMD)
    
    Power_Off = DLE_DC4_FN2_CMD
    
End Function

Public Function Stamp(KeyCode1 As Integer, KeyCode2 As Integer, Width As Integer, Height As Integer, LineSpace As Integer, CharSpace As Integer, OffSet As Integer) As Byte()

    Dim Target() As Byte

    Target = Add_Array(Print_NV_Data(0, 0, KeyCode1, KeyCode2, Width, Height, LineSpace, CharSpace, OffSet), Cut(1))
    Stamp = Target
    
End Function

Public Function Define_UserFont(HighByte As Integer, LowByte As Integer, FontData() As Byte) As Byte()
    
    Define_UserFont = FS_Two_CMD(HighByte, LowByte, FontData())
    
End Function

Public Function Print_UserFont(HighByte As Integer, LowByte As Integer) As Byte()
    
    Dim Target() As Byte
    Dim ESC_CMD(1) As Byte
    ESC_CMD(0) = HighByte
    ESC_CMD(1) = LowByte
 
    Target = Add_Array(FS_Ampersand_CMD, ESC_CMD())
    
    Print_UserFont = Target
    
End Function

Public Function Cancel_UserFont(HighByte As Integer, LowByte As Integer) As Byte()
    
    Cancel_UserFont = FS_Question_Mark_CMD(HighByte, LowByte)
    
End Function
Public Function UTF8_Encode(ByVal strUnicode As String) As Byte()
'UTF-8 sX

    Dim TLen As Long
    Dim lngBufferSize As Long
    Dim lngResult As Long
    Dim bytUtf8() As Byte
    
    TLen = Len(strUnicode)
    If TLen = 0 Then Exit Function
    
    lngBufferSize = TLen * 3 + 1
    ReDim bytUtf8(lngBufferSize - 1)
    
    lngResult = WideCharToMultiByte(CP_UTF8, 0, StrPtr(strUnicode), TLen, bytUtf8(0), lngBufferSize, vbNullString, 0)
    
    If lngResult <> 0 Then
        lngResult = lngResult - 1
        ReDim Preserve bytUtf8(lngResult)
    End If
    
    UTF8_Encode = bytUtf8
End Function
Public Function UTF8_Decode(ByRef bUTF8() As Byte) As String
'UTF-8 ѽX
    Dim lRet As Long
    Dim lLen As Long
    Dim lBufferSize As Long
    Dim sBuffer As String
    Dim bBuffer() As Byte
    
    lLen = UBound(bUTF8) + 1
    
    If lLen = 0 Then Exit Function
    
    lBufferSize = lLen * 2
    
    sBuffer = String$(lBufferSize, Chr(0))
    
    lRet = MultiByteToWideChar(CP_UTF8, 0, VarPtr(bUTF8(0)), lLen, StrPtr(sBuffer), lBufferSize)
    
    If lRet <> 0 Then
        sBuffer = Left(sBuffer, lRet)
    End If
    
    UTF8_Decode = sBuffer
End Function

